src/main/EPPW.Web/Areas/Admin/Controllers/AdminProgramController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EPPW.Membership.Dto;
using EPPW.Membership.Service;
using Sliverant.Web.Common;

namespace EPPW.Web.Areas.Admin.Controllers
{
    [AllowAnonymous]
    public class AdminProgramController : BaseController
    {
        public IProgramService ProgramService { private get; set; }
        // GET: /AdminMng/AdminProgram/

        public ActionResult Index(string id)
        {
            List<ProgramDto> result = ProgramService.GetAllProgramDto();

            return View(result);
        }
 

        // GET: /AdminMng/AdminProgram/Details/5

        public ActionResult Details(int id)
        {
            ProgramDto programDto = ProgramService.GetProgramDtoById(id);

            return View(programDto);
        }

        public ActionResult ProgramsInRole(int id, string programName)
        {
            List<RoleDto> roleList = ProgramService.GetRoleDtoByProgramId(id);
            ViewBag.ProgramName = programName;
            return View(roleList);
        }

        // GET: /AdminMng/AdminProgram/Create

        public ActionResult Create(string id)
        {

            return View();
        }

        // POST: /AdminMng/AdminProgram/Create

        [HttpPost]
        public ActionResult Create(ProgramDto programDto)
        {
            try
            {
                // TODO: Add insert logic here
                //Modify By JiangYaFei 2014-8-12 14:29:55
                ProgramService.AddProgramDto(programDto, SessionService.UserInfo.UserId);
                return RedirectToAction("Index");
            }
            catch(Exception ex)
            {
                return View();
            }
        }

        // GET: /AdminMng/AdminProgram/Edit/5

        public ActionResult Edit(int id)
        {
            ProgramDto programDto = ProgramService.GetProgramDtoById(id);
            return View(programDto);
        }

        // POST: /AdminMng/AdminProgram/Edit/5

        [HttpPost]
        public ActionResult Edit(int id, ProgramDto programDto)
        {
            try
            {
                // TODO: Add update logic here
                ProgramService.UpdateProgramDto(programDto, SessionService.UserInfo.UserId);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: /AdminMng/AdminProgram/Delete/5

        public ActionResult Delete(int id)
        {
            ProgramDto programDto = ProgramService.GetProgramDtoById(id);
            return View(programDto);
        }

        // POST: /AdminMng/AdminProgram/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here
                ProgramService.DeleteProgramDtoById(id);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public JsonResult ProgramListByRole()
        {
            List<ProgramDto> appPrograms = ProgramService.GetAllProgramDto();

            var result = from program in appPrograms
                         select new
                         {
                             check = String.Format("<input type=\"checkbox\" name=\"Programs\" value=\"{0}\">", program.ProgramId)
                             ,
                             Code = program.Code
                             ,
                             Name = program.Name
                             ,
                             Desc = program.Description
                         };

            return Json(new { aaData = result }, JsonRequestBehavior.AllowGet);
        }
    }
}

src/main/EPPW.Web/Areas/Admin/Controllers/AdminProgramMenuController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EPPW.Membership.Service;
using EPPW.Membership.Dto;
using EPPW.Web.Common;
using Sliverant.Web.Common;

namespace EPPW.Web.Areas.Admin.Controllers
{
    [AllowAnonymous]
    public class AdminProgramMenuController : BaseController
    {
        // GET: /AdminMng/ProgramMenu/
        public IProgramMenuService ProgramMenuService { get; set; }
        public IProgramService ProgramService { get; set; }

        public ActionResult Index(string id)
        {
            List<ProgramMenuDto> result = ProgramMenuService.GetAllProgramMenuDto();

            return View(result);
        }

        public ActionResult Create()
        {
            return View();
        }

        // POST: /AdminMng/ProgramMenu/Create

        [HttpPost]
        public ActionResult Create(ProgramMenuDto programMenuDto)
        {
            try
            {
                // TODO: Add insert logic here
                ProgramMenuService.AddProgramMenuDto(programMenuDto);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: /AdminMng/ProgramMenu/Edit/5

        public ActionResult Edit(int id)
        {
            ProgramMenuDto programMenuDto = ProgramMenuService.GetProgramMenuDto(id);
            return View(programMenuDto);
        }

        // POST: /AdminMng/ProgramMenu/Edit/5

        [HttpPost]
        public ActionResult Edit(ProgramMenuDto programMenuDto)
        {
            try
            {
                // TODO: Add update logic here

                ProgramMenuService.UpdateProgramMenuDto(programMenuDto);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: /AdminMng/ProgramMenu/Delete/5

        public ActionResult Delete(int id)
        {
            ProgramMenuDto programMenuDto = ProgramMenuService.GetProgramMenuDto(id);
            return View(programMenuDto);
        }

        // POST: /AdminMng/ProgramMenu/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here
                ProgramMenuService.DeleteProgramMenuDtoById(id);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        [HttpPost]
        public JsonResult UpdateProgramToMenu(int menuId,int programId)
        {
            int? programIdInt = programId;
            if (programId == 0)
                programIdInt = null;
            ProgramMenuService.UpdateProgramIdByMenuId(menuId, programIdInt);

            return Json(new { result = true }, JsonRequestBehavior.AllowGet);
        
        }

        public JsonResult GetAllProgramDtoList(int programMenuId,int programId)
        {
            List<ProgramDto> programDtoList = ProgramService.GetAllProgramDto();
            var result = from program in programDtoList
                         select new
                         {
                             check = String.Format("<input type=\"checkbox\" name=\"Programs\" value=\"{0}\" {1}>", program.ProgramId, program.ProgramId == programId ? "checked=\"checked\"" : "")
                             ,
                             Code = program.Code
                             ,
                             Name = program.Name
                         };

            return Json(new { aaData = result }, JsonRequestBehavior.AllowGet);
        }

     
    }
}

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/Create.cshtml
@model EPPW.Membership.Dto.ProgramMenuDto
@{
    ViewBag.Title = "Create";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section SideContent
{
    <div class="row-fluid">
        <div class="span12">
            <blockquote>
                <p>
                    Program Menu</p>
            </blockquote>
        </div>
    </div>
}
<div class="row-fluid">
    <div class="span2">
    </div>
    <div class="span10">
        @using (Html.BeginForm(ViewContext.RouteData.GetRequiredString("action"), ViewContext.RouteData.GetRequiredString("controller"), FormMethod.Post, new { @class = "form-horizontal" }))
        {
            <fieldset>
                <legend>Program Menu Create</legend>
                <div class="control-group">
                    @Html.LabelFor(model => model.DisplaySeq, new { @class = "control-label" })
                    <div class="controls">
                        @Html.EditorFor(model => model.DisplaySeq, "", new { placeholder = "DisplaySeq" })
                        @Html.ValidationMessageFor(model => model.DisplaySeq)
                    </div>
                </div>
                <div class="control-group">
                    @Html.LabelFor(model => model.ParentId, new { @class = "control-label" })
                    <div class="controls">
                        @Html.EditorFor(model => model.ParentId, "", new { placeholder = "ParentId" })
                        @Html.ValidationMessageFor(model => model.ParentId)
                    </div>
                </div>
                <div class="control-group">
                    @Html.LabelFor(model => model.Name, new { @class = "control-label" })
                    <div class="controls">
                        @Html.EditorFor(model => model.Name, "", new { placeholder = "Name" })
                        @Html.ValidationMessageFor(model => model.Name)
                    </div>
                </div>
                <div class="control-group">
                    @Html.LabelFor(model => model.Description, new { @class = "control-label" })
                    <div class="controls">
                        @Html.EditorFor(model => model.Description, "", new { placeholder = "Desc" })
                        @Html.ValidationMessageFor(model => model.Description)
                    </div>
                </div>
                <div class="control-group">
                    @Html.LabelFor(model => model.Parameter, new { @class = "control-label" })
                    <div class="controls">
                        @Html.EditorFor(model => model.Parameter, "", new { placeholder = "Parameter" })
                        @Html.ValidationMessageFor(model => model.Parameter)
                    </div>
                </div>
                <p>
                    <input type="submit" value="Create" />
                </p>
            </fieldset>
        }
    </div>
</div>
<div>
    @Html.ActionLink("Back to List", "Index")
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/Delete.cshtml
@model EPPW.Membership.Dto.ProgramMenuDto
@{
    ViewBag.Title = "Delete";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section SideContent
{
    <div class="row-fluid">
        <div class="span12">
            <blockquote>
                <p>
                    ProgramMenu</p>
            </blockquote>
        </div>
    </div>
}
<div class="row-fluid">
    <div class="span2">
    </div>
    <div class="span10">
        <h2>
            Delete</h2>
        <h3>
            Are you sure you want to delete this?</h3>
        <fieldset>
            <legend>Delete a ProgramMenu</legend>
            <div class="display-label">
                @Html.DisplayNameFor(model => model.DisplaySeq)
            </div>
            <div class="display-field">
                @Html.DisplayFor(model => model.DisplaySeq)
            </div>
            <div class="display-label">
                @Html.DisplayNameFor(model => model.ParentId)
            </div>
            <div class="display-field">
                @Html.DisplayFor(model => model.ParentId)
            </div>
            <div class="display-label">
                @Html.DisplayNameFor(model => model.Name)
            </div>
            <div class="display-field">
                @Html.DisplayFor(model => model.Name)
            </div>
            <div class="display-label">
                @Html.DisplayNameFor(model => model.Description)
            </div>
            <div class="display-field">
                @Html.DisplayFor(model => model.Description)
            </div>
            <div class="display-label">
                @Html.DisplayNameFor(model => model.Parameter)
            </div>
            <div class="display-field">
                @Html.DisplayFor(model => model.Parameter)
            </div>
        </fieldset>
        @using (Html.BeginForm())
        {
            <p>
                <input type="submit" value="Delete" />
                |
                @Html.ActionLink("Back to List", "Index")
            </p>
        }
    </div>
</div>

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/Edit.cshtml
@model EPPW.Membership.Dto.ProgramMenuDto
@{
    ViewBag.Title = "Edit";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section SideContent
{
    <div class="row-fluid">
        <div class="span12">
            <blockquote>
                <p>
                    ProgramMenu</p>
            </blockquote>
        </div>
    </div>
}
<div class="row-fluid">
    <div class="span2">
    </div>
    <div class="span10">
        @using (Html.BeginForm())
        {
            @Html.ValidationSummary(true)

            <fieldset>
                <legend>ProgramMenu Edit</legend>
                <div class="editor-label">
                    @Html.LabelFor(model => model.DisplaySeq)
                </div>
                <div class="editor-field">
                    @Html.EditorFor(model => model.DisplaySeq)
                    @Html.ValidationMessageFor(model => model.DisplaySeq)
                </div>
                <div class="editor-label">
                    @Html.LabelFor(model => model.ParentId)
                </div>
                <div class="editor-field">
                    @Html.EditorFor(model => model.ParentId)
                    @Html.ValidationMessageFor(model => model.ParentId)
                </div>
                @Html.HiddenFor(model => model.Id)
                <div class="editor-label">
                    @Html.LabelFor(model => model.Name)
                </div>
                <div class="editor-field">
                    @Html.EditorFor(model => model.Name)
                    @Html.ValidationMessageFor(model => model.Name)
                </div>
                <div class="editor-label">
                    @Html.LabelFor(model => model.Description)
                </div>
                <div class="editor-field">
                    @Html.EditorFor(model => model.Description)
                    @Html.ValidationMessageFor(model => model.Description)
                </div>
                <div class="editor-label">
                    @Html.LabelFor(model => model.Parameter)
                </div>
                <div class="editor-field">
                    @Html.EditorFor(model => model.Parameter)
                    @Html.ValidationMessageFor(model => model.Parameter)
                </div>
                <p>
                    <input type="submit" value="Save" />
                </p>
            </fieldset>
        }
        <div>
            @Html.ActionLink("Back to List", "Index")
        </div>
    </div>
</div>
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/Index.cshtml
@model IEnumerable<EPPW.Membership.Dto.ProgramMenuDto>
@{
    ViewBag.Title = "Index";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section SideContent
{
    <div class="row-fluid">
        <div class="span12">
            <blockquote>
                <p>
                    Program Menu</p>
                <small>Program Menu list</small>
            </blockquote>
            <p>
                <a href="@Url.Action("Create")" class="btn btn-small" ><i class="icon-plus"></i>Create</a>
            </p>
        </div>
    </div>
}
<div class="row-fluid">
    <div class="span12">
        @Html.Partial("../AdminProgramMenu/_Table", Model)
    </div>
</div>
<div>
    @Html.Partial("../AdminProgramMenu/ShowProgramPopup", Model)
</div>
@section HeadCss
{
    @Styles.Render("~/Content/plugins/datatables")
}

@section Scripts
{
    @Scripts.Render("~/Scripts/Plugins/datatables")
    <script type="text/javascript">

        var menuIdAndprogramIdJSON;
        $(function () {
            //1. 显示Popup之前，存取programMenuId 和 programId
            $('#ProgramMenuTable #btnAddOrUpdateProgram').each(function (i, val) {
                $(this).click(function () {
                    var menuIdAndprogramIdStr = $(this).val();
                    menuIdAndprogramIdJSON = eval("(" + menuIdAndprogramIdStr + ")");
                    $('#LinkProgramModal').modal("show");
                });
            });
            //2.1 显示Popup，并且在后台把需要选中的checkbox勾上
            //2.2 点击复选框时，把其他的复选框全部清空
            $('#LinkProgramModal').on('show', function () {
                $('#AddProgramTable').dataTable({
                    "bRetrieve": true,
                    "bProcessing": true,
                    "sAjaxSource": '/Admin/AdminProgramMenu/GetAllProgramDtoList/?programMenuId=' + menuIdAndprogramIdJSON.programMenuId + "&programId=" + menuIdAndprogramIdJSON.programId,
                    //"sServerMethod": "GET",
                    "fnDrawCallback": function () {
                        var programId;
                        $("input:checkbox[name=Programs]").on("change", function () {
                            programId = $(this).val();
                            $("input:checkbox[name=Programs]").each(function () {
                                if ($(this).val() != programId) {
                                    $(this).attr("checked", false);
                                }
                            });
                        });
                    },
                    "aoColumns": [
                        { "mData": "check" },
                        { "mData": "Code" },
                        { "mData": "Name" },
                    ]
                });
            });
            //3. 保存，更新菜单对应的programId
            $("#btnAddProgramToMenu").on("click", function () {
                var url = '/Admin/AdminProgramMenu/UpdateProgramToMenu'
                $('#LinkProgramModal').modal('hide');
                var programId;
                var selectedCheckbox = $("input:checkbox[name=Programs]:checked");
                if (selectedCheckbox.length == 0) {
                    programId = 0;
                }
                else {
                    programId = selectedCheckbox.val();
                }
                $.post(url, { menuId: menuIdAndprogramIdJSON.programMenuId, programId: programId }, function () {
                    location.reload();
                }, "json");
            });
        });
    </script>
}

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/ShowProgramPopup.cshtml
<div id="LinkProgramModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="AddProgramLabel"
    aria-hidden="true">
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
            ×</button>
        <h3 id="AddProgramLabel">
            Add Program</h3>
    </div>
    <div class="modal-body">
        <table id="AddProgramTable" class="table table-bordered zebra-striped dataTable table-hover table-condensed">
            <thead>
                <tr>
                    <th style="width: 10px;">
                        Select
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="AddProgramTable"
                        rowspan="1" colspan="1" style="width: 30px;">
                        Code
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="AddProgramTable"
                        rowspan="1" colspan="1" style="width: 30px;">
                        Name
                    </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
    <div class="modal-footer">
        <button class="btn" data-dismiss="modal" aria-hidden="true">
            Close</button>
        <button id="btnAddProgramToMenu" type="button" class="btn btn">
            Save</button>
    </div>
</div>

src/main/EPPW.Web/Areas/Admin/Views/AdminProgramMenu/_Table.cshtml
@model IEnumerable<EPPW.Membership.Dto.ProgramMenuDto>
<table id="ProgramMenuTable" class="table table-bordered zebra-striped dataTable table-hover table-condensed">
    <thead>
        <tr role="row">
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 30px;">
                Id
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 30px;">
                ParentId
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 30px;">
                DisplaySeq
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 106px;">
                Name
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 106px;">
                Desc
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 106px;">
                Program
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 106px;">
                Program Detail
            </th>
            <th class="header" role="columnheader" tabindex="0" aria-controls="ProgramMenuTable"
                rowspan="1" colspan="1" style="width: 106px;">
            </th>
        </tr>
    </thead>
    <tbody>
        @if (Model == null)
        {
            <tr>
                <td colspan="4">
                    <p>
                        没有查询的数据。</p>
                </td>
            </tr>
        }
        else
        {
            foreach (EPPW.Membership.Dto.ProgramMenuDto item in Model)
            {
            <tr>
                <td>@Html.DisplayFor(modelItem => item.Id)
                </td>
                <td>@Html.DisplayFor(modelItem => item.ParentId)
                </td>
                <td>@Html.DisplayFor(modelItem => item.DisplaySeq)
                </td>
                <td>@Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Description)
                </td>
                <td>
                    <button id="btnAddOrUpdateProgram" type="button" class="btn btn-small" value="{programMenuId:@item.Id,programId:@item.ProgramId}">
                        <i class='icon-plus-sign'></i>Link Program</button>
                </td>
                <td>
                    @if (item.ProgramId != 0)
                    {
                        <a href="@Url.Action("Details", "AdminProgram", new { id = item.ProgramId })" class="btn btn-small">
                            <i class='icon-list-alt'></i>@item.ProgramName </a>
                    }
                </td>
                <td>
                    <div class="btn-group">
                        <a href="@Url.Action("Edit", "AdminProgramMenu", new { id = item.Id })" class="btn btn-small " title="Edit" >
                            <i class='icon-edit'></i></a><a href="@Url.Action("Delete", "AdminProgramMenu", new { id = item.Id })" class="btn btn-small " title="Delete">
                                <i class='icon-trash'></i></a>)</div>
                </td>
           
            </tr>
            }
        }
    </tbody>
</table>